local addonName, vars = ...

-- uncomment one of the following to set modifier to allow tab dragging
local overrideModifier = 
   IsShiftKeyDown
-- IsModifierKeyDown
-- IsAltKeyDown
-- IsControlKeyDown
-- nil -- disable modifier

local frameHooked = {}

-- disable drag-to-undock for chat window tabs
local function fixFrame(chatFrame)
   if chatFrame and chatFrame ~= DEFAULT_CHAT_FRAME then
      local name = chatFrame.GetName and chatFrame:GetName()
      local tab = name and _G[name.."Tab"];
      if tab and not frameHooked[tab] then
         frameHooked[tab] = true
         local fn = tab:GetScript("OnDragStart")
         tab:SetScript("OnDragStart", function(self)
               if not chatFrame.isDocked or (overrideModifier and overrideModifier()) then
                  fn(self)
               end
         end)
      end
   end
end

for i=1,NUM_CHAT_WINDOWS do
   fixFrame(_G["ChatFrame"..i])
end

hooksecurefunc("FCF_DockFrame", fixFrame)
